<?php

namespace FiloBlu\Kpi\Model;

class Createviews extends Core
{

    /*
     * This function will read all the attributes from the kpi/table_configuration/fields config
     * And return one array with them
     */
    public function getAttributesFromKpiConfig(){
        $attributes = $this->_scopeConfig->getValue('kpi/table_configuration/fields');

        if(!$attributes){
            return false;
        }

        $attributes = $this->_serializer->unserialize($attributes);

        $attributes_array = array();
        foreach ($attributes as $key => $data) {
            // Fallback if missing column_name from backend config
            if(!$data['column_name']){
                $data['column_name'] = $data['catalog_product_attribute'];
            }
            $attributes_array[] = $data;
        }
        return $attributes_array;
    }

    public function createViews(){
        $this->createCustomersBiView();
        $this->createProductsBiView();
        return true;
    }

    public function createCustomersBiView(){
        $queryCustomer = $this->getCustomerCollection()->getSelect()->__toString();
        $queryFinalCustomer = "CREATE OR REPLACE VIEW `customer_bi` AS " . str_replace("INNER", "LEFT", $queryCustomer);
        $this->getConnection()->query($queryFinalCustomer);
        return true;
    }

    public function createProductsBiView(){

        $attributes = $this->getAttributesFromKpiConfig();

        $productCollection = $this->getProductsCollection();
        $productCollection->addStoreFilter($this->_storeManagerInterface->getStore($this->getDefaultStoreId()));
        $productCollection->addAttributeToFilter('type_id', 'simple');
        //$productCollection->addAttributeToSelect('url_image_kpi', 'left');

        foreach ($attributes as $attribute_data) {
            $productCollection->addAttributeToSelect($attribute_data['catalog_product_attribute'], 'left');
        }

        $queryProduct = $productCollection->getSelect()->__toString();
        $queryFinalProduct = "CREATE OR REPLACE VIEW `product_bi` AS " . $queryProduct;

        //Fixing column names for the view
        foreach ($attributes as $attribute_data) {
            $string_to_change = "` AS `{$attribute_data['catalog_product_attribute']}`";
            $change_in = "` AS `{$attribute_data['column_name']}`";
            $queryFinalProduct = str_replace($string_to_change,$change_in,$queryFinalProduct);
        }

        $this->getConnection()->query($queryFinalProduct);

        return true;
    }

}